# TODO:
# - consider name change
#
Summary:	LDAP Name Service Switch Module
Summary(es.UTF-8):	Biblioteca NSS para LDAP
Summary(pl.UTF-8):	Moduł NSS LDAP
Summary(pt_BR.UTF-8):	Biblioteca NSS para LDAP
Name:		nss_ldapd
Version:	0.9.2
Release:	5
License:	LGPL v2.1+
Group:		Base
Source0:	http://arthurdejong.org/nss-pam-ldapd/nss-pam-ldapd-%{version}.tar.gz
# Source0-md5:	0c60d4c300dd9a4fb40b6ba7abeed8a2
Source1:	nslcd.init
Source2:	nslcd.service
Source3:	nslcd.tmpfiles
Patch0:		%{name}-no-root.patch
Patch1:		optimize-queries.patch
Patch2:		ntohl-signedness.patch
Patch3:		fix-to_date.patch
Patch4:		shadowExpire-from-AD.patch
URL:		http://arthurdejong.org/nss-pam-ldapd/
BuildRequires:	autoconf >= 2.61
BuildRequires:	automake
BuildRequires:	cyrus-sasl-devel
BuildRequires:	docbook2X
BuildRequires:	heimdal-devel
BuildRequires:	openldap-devel >= 2.3.0
BuildRequires:	pam-devel
BuildRequires:	rpmbuild(macros) >= 1.671
Requires:	nslcd = %{version}-%{release}
Conflicts:	nss_ldap
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_libdir		/%{_lib}

%description
nss_ldapd is a C library extension (NSS module) and daemon which
allows X.500 and LDAP directory servers to be used as a primary source
of aliases, ethers, groups, hosts, networks, protocols, users, RPCs,
services and shadow passwords (instead of or in addition to using flat
files or NIS).

%description -l pl.UTF-8
Moduł serwisu nazw oraz osobny demon. Ten pakiet pozwala na
korzystanie z serwerów X.500 i LDAP jako źródła aliasów, grup, hostów,
sieci, protokołów, użytkowników, RPC, usług i haseł (zamiast lub
oprócz zwykłych plików lub NIS).

nss_ldapd jest forkiem projektu nss_ldap. Celem projektu jest
naprawienie pewnych problemów z nss_ldap poprzez wydzielenie kodu LDAP
do osobnego demona.

%package nslcd
Summary:	NSS LDAPD name service daemon
Summary(pl.UTF-8):	Demon serwisu nazw NSS LDAPD
Group:		Base
Requires(post,preun):	/sbin/chkconfig
Requires(post,preun,postun):	systemd-units >= 38
Requires:	rc-scripts >= 0.2.0
Requires:	systemd-units >= 38
Provides:	nslcd = %{version}-%{release}

%description nslcd
NSS LDAPD name service daemon.

%description nslcd -l pl.UTF-8
Demon serwisu nazw NSS LDAPD.

%package nslcd-utils
Summary:	Utilities using NSLCD for LDAPD operations
Summary(pl.UTF-8):	Demon serwisu nazw NSS LDAPD
Group:		Base
Requires:	nslcd = %{version}-%{release}

%description nslcd-utils
Utilities using NSLCD for LDAPD operations.

%description nslcd-utils -l pl.UTF-8
Narzędzia wykorzystujące NSLCD do operacji LDAP-owych.

%package pam
Summary:	NSS LDAPD Pluggable Authentication Module
Summary(pl.UTF-8):	Moduł PAM do uwierzytelniania z użyciem NSS LDAPD
Group:		Base
Requires:	nslcd = %{version}-%{release}
Conflicts:	pam-pam_ldap

%description pam
This is pam_ldap, a pluggable authentication module that can be used
with linux-PAM. This module supports authentication, account
management, password management and session management.

%description pam -l pl.UTF-8
To jest pam_ldap, wymienny moduł uwierzytelniania, który może być
użyty z linux-PAM. Moduł ten wspiera autentykację, obsługę kont,
zmianę haseł i obsługę sesji.

%prep
%setup -q -n nss-pam-ldapd-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%{__sed} -i -e '1s|#!.*|#!%{__python}|' utils/*.py

%build
%configure \
	DOCBOOK2X_MAN=/usr/bin/docbook2X2man \
	--with-pam-seclib-dir=/%{_lib}/security \
	--with-ldap-lib=openldap

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},/etc/rc.d/init.d,/var/run/nslcd} \
	$RPM_BUILD_ROOT{%{systemdunitdir},%{systemdtmpfilesdir}}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/nslcd
install %{SOURCE2} $RPM_BUILD_ROOT%{systemdunitdir}/nslcd.service
install %{SOURCE3} $RPM_BUILD_ROOT%{systemdtmpfilesdir}/nslcd.conf

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%pre nslcd
%useradd -u 21 -d /usr/share/empty -s /bin/false -c "NSS LDAP Cache Daemon User" -g nobody nslcd

%post nslcd
/sbin/chkconfig --add nslcd
%service nslcd restart "NSS LDAP Cache Daemon"
%systemd_post nslcd.service

%preun nslcd
if [ "$1" = "0" ]; then
	%service nslcd stop
	/sbin/chkconfig --del nslcd
fi
%systemd_preun nslcd.service

%postun nslcd
if [ "$1" = "0" ]; then
	%userremove nslcd
fi
%systemd_reload

%triggerpostun nslcd -- nss_ldapd < 0.7.0
if [ -e %{_sysconfdir}/nss-ldapd.conf.rpmsave ]; then
	mv -f %{_sysconfdir}/nslcd.conf{,rpmnew}
	mv -f %{_sysconfdir}/nss-ldapd.conf.rpmsave %{_sysconfdir}/nslcd.conf
fi

%triggerpostun nslcd -- nslcd < 0.9.2-1
%systemd_trigger nslcd.service

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog NEWS README TODO
%attr(755,root,root) %{_libdir}/libnss_ldap.so.2

%files nslcd
%defattr(644,root,root,755)
%attr(754,root,root) /etc/rc.d/init.d/nslcd
%{systemdunitdir}/nslcd.service
%attr(640,nslcd,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/nslcd.conf
%attr(755,root,root) %{_sbindir}/nslcd
%{_mandir}/man5/nslcd.conf.5*
%{_mandir}/man8/nslcd.8*
%dir /var/run/nslcd
%{systemdtmpfilesdir}/nslcd.conf

%files nslcd-utils
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/chsh.ldap
%attr(755,root,root) %{_bindir}/getent.ldap
%attr(755,root,root) %{_datadir}/nslcd-utils/chsh.py
%dir %{_datadir}/nslcd-utils
%{_datadir}/nslcd-utils/cmdline.py
%{_datadir}/nslcd-utils/constants.py
%attr(755,root,root) %{_datadir}/nslcd-utils/getent.py
%{_datadir}/nslcd-utils/nslcd.py
%{_datadir}/nslcd-utils/shells.py
%{_datadir}/nslcd-utils/users.py
%{_datadir}/nslcd-utils/*.py[co]
%{_mandir}/man1/chsh.ldap.1*
%{_mandir}/man1/getent.ldap.1*

%files pam
%defattr(644,root,root,755)
%attr(755,root,root) /%{_lib}/security/pam_ldap.so
%{_mandir}/man8/pam_ldap.8*
%changelog
* Wed Dec 25 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/nss_ldapd.git;a=log;h=master

* Wed Dec 25 2013 Jan Rękorajski <baggins@pld-linux.org> 1c96bb7
- rel 5

* Wed Dec 25 2013 Jan Rękorajski <baggins@pld-linux.org> eef43a7
- use proper attr for expiration
- added "never expire" checks

* Wed Dec 25 2013 Jan Rękorajski <baggins@pld-linux.org> a89df22
- apply shadowExpire patch

* Wed Dec 25 2013 Jan Rękorajski <baggins@pld-linux.org> a143cf5
- add functionality to map shadowExpire from AD accountExpires attr

* Thu Dec 12 2013 Jan Rękorajski <baggins@pld-linux.org> cbd95ec
- rel 4

* Thu Dec 12 2013 Jan Rękorajski <baggins@pld-linux.org> d808c7b
- use proper buffer when converting date from AD format

* Thu Dec 12 2013 Jan Rękorajski <baggins@pld-linux.org> 0ffd2c0
- signed values are written over the wire, but ntohl is working on unsigned types

* Thu Dec 12 2013 Jan Rękorajski <baggins@pld-linux.org> ee7f953
- move broadest search condition to the end of search filter

* Tue Dec 10 2013 Jan Rękorajski <baggins@pld-linux.org> baee27f
- restore internal deps
- add missing dir
- rel 2

* Tue Dec 10 2013 Jan Rękorajski <baggins@pld-linux.org> ee246e9
- updated to 0.9.2
- added utils subpackage
- added systemd service
- renamed tmpfiles config, it's only for nslcd
- moved deamon deps to nslcd package

* Sun Mar 10 2013 Jakub Bogusz <qboosh@pld-linux.org> 95b9e33
- updated to 0.8.12
- strict nslcd dependencies as protocol may change

* Mon Oct 01 2012 Tomasz Rutkowski <alucard@pld-linux.org> 77c7d56
- up to 0.8.10

* Fri Jun 01 2012 Andrzej Zawadzki <zawadaa@gmail.com> 5e229d0
- up to 0.8.5, works

* Thu Feb 09 2012 Elan Ruusamäe <glen@pld-linux.org> 865918b
- revert ldap bump

* Tue Jan 31 2012 Jan Rękorajski <baggins@pld-linux.org> 4000b99
- release 2

* Tue Jan 31 2012 Jan Rękorajski <baggins@pld-linux.org> 2b10727
- added tmpfiles config for systemd

* Mon Jan 30 2012 Jan Rękorajski <baggins@pld-linux.org> a31ab8f
- add systemd tmpfiles config

* Tue Sep 27 2011 Jan Rękorajski <baggins@pld-linux.org> 055c92e
- 0.8.4

* Thu Aug 04 2011 Jan Rękorajski <baggins@pld-linux.org> f3f1924
- rel 2
- that _libdir WAS NOT FOR PAM! it was for NSS module!

* Wed Aug 03 2011 Jan Rękorajski <baggins@pld-linux.org> c14595b
- 0.8.3

